#!/bin/bash
#
# By -- WRQC343 -- gmrs-link.com
#
# Ver 1.1 - 8/26/24
#
#  Base install

link="http://gmrs-link.com/rsync/pi-monitor"
lan_ip=$(hostname -i)
wan_ip=$(curl -s https://ipinfo.io/ip) 
  
    echo ""
    echo "Creating Folders"
   
    mkdir /etc/asterisk/local/pi-monitor || exit 1

sleep 1   

    mkdir /etc/asterisk/local/pi-monitor/sound || exit 1
   
    echo "Folders - Complete"
    echo ""
     
    echo "Downloading Files"
   
    wget -P /etc/asterisk/local/pi-monitor/ $link/Fetch.sh -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/pi-monitor/Fetch.sh
   
    wget -P /etc/asterisk/local/pi-monitor/ $link/Base.sh -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/pi-monitor/Base.sh
   
    wget -P /etc/asterisk/local/pi-monitor/sound/ $link/sound/high-temp-alarm.gsm -q --show-progress || exit 1
   
    wget -P /etc/asterisk/local/pi-monitor/ $link/Fetch-ip-list.txt -q --show-progress || exit 1
      
    wget -P /srv/http/ $link/web/bkimg.jpg -q --show-progress || exit 1
      
    wget -P /srv/http/ $link/web/style-temp.css -q --show-progress || exit 1
      
    wget -P /srv/http/ $link/web/temp-stats.html -q --show-progress || exit 1
   
    echo "File Download - Complete"
    echo "Permissions Set"
    echo ""
   
    echo "Building File Structure"
   
    ln -s /tmp/pi-temp-1.php /srv/http/pi-temp-1.php
   
sleep 1
   
    ln -s /tmp/pi-monitor-clist.php /srv/http/pi-monitor-clist.php
   
    echo "File Structure - Complete"  
    echo ""
   
    echo "Backup Current Cron File"
   
    cp /var/spool/cron/root /var/spool/cron/root_`date +"%Y%m%d"`.bak
   
    echo "Cron Backup - Complete"
    echo ""
      
    echo "Checking Cron for existing entries"
   
    crontab -l | grep '/etc/asterisk/local/pi-monitor/Fetch.sh' 1>/dev/null 2>&1 
    (( $? == 0 )) && echo "Cron Error" && exit 

    crontab -l | grep '/etc/asterisk/local/pi-monitor/Base.sh' 1>/dev/null 2>&1 
    (( $? == 0 )) && echo "Cron Error" && exit 
   
    echo "Cron Check - Complete"
    echo ""
    
    crontab -l >/tmp/crontab.tmp 
  
    echo "Adding Cron Strings"
   
    echo '*/29 * * * * /etc/asterisk/local/pi-monitor/Base.sh' >> /tmp/crontab.tmp 
    echo '*/30 * * * * /etc/asterisk/local/pi-monitor/Fetch.sh' >> /tmp/crontab.tmp 
    
    crontab /tmp/crontab.tmp 
 
    rm /tmp/crontab.tmp 
   
    echo "Cron File - Complete"
    echo ""
   
    echo "Your LAN IP Address is: $lan_ip"
    echo "Your WAN IP Address is: $wan_ip"
    echo ""
    echo Enter This Nodes Number #?
    read var1
    echo ""
    echo Enter Base IP Address #?
    read var2 
    echo ""
    echo -e "Enter Remote 1 IP Address (Enter for NONE)#?"
    read var3
    echo ""
    echo -e "Enter Remote 2 IP Address (Enter for NONE)#?"
    read var4 
    echo ""
    echo -e "Enter Remote 3 IP Address (Enter for NONE)#?"
    read var5
    echo ""

    echo "Checking Files for String Markers"
   
    grep 'xxxx' /etc/asterisk/local/pi-monitor/Base.sh >/dev/null 2>&1 
    grep '{BASEIP}' /etc/asterisk/local/pi-monitor/Fetch-ip-list.txt >/dev/null 2>&1
    grep '{REMOTEIP1}' /etc/asterisk/local/pi-monitor/Fetch-ip-list.txt >/dev/null 2>&1
    grep '{REMOTEIP2}' /etc/asterisk/local/pi-monitor/Fetch-ip-list.txt >/dev/null 2>&1
    grep '{REMOTEIP3}' /etc/asterisk/local/pi-monitor/Fetch-ip-list.txt >/dev/null 2>&1
    EXIT="$?"

 if [[ "$EXIT" == "0" ]]
  then
	  :

 elif [[ "$EXIT" == "1" ]]
  then
        echo "No matches in files!"
        exit

  else
  	    echo "Encountered an Error: $EXIT."

fi
   
    echo "File Check - Complete"
    echo ""
   
sleep 2   

    echo "Adding Base.sh & Fetch-ip-list.txt Strings"
   
    sed -i 's|'xxxx'|'$var1'|g' /etc/asterisk/local/pi-monitor/Base.sh
    sed -i 's|'\{BASEIP\}'|'http:\/\/$var2\/pi-temp-1.php'|g' /etc/asterisk/local/pi-monitor/Fetch-ip-list.txt
    sed -i 's|'\{REMOTEIP1\}'|'http:\/\/$var3\/pi\-temp\-2\.php'|g' /etc/asterisk/local/pi-monitor/Fetch-ip-list.txt
    sed -i 's|'\{REMOTEIP2\}'|'http:\/\/$var4\/pi\-temp\-3\.php'|g' /etc/asterisk/local/pi-monitor/Fetch-ip-list.txt
    sed -i 's|'\{REMOTEIP3\}'|'http:\/\/$var5\/pi\-temp\-4\.php'|g' /etc/asterisk/local/pi-monitor/Fetch-ip-list.txt
   
    echo "Data Entry - Complete"
    echo ""
   
sleep 4

    rm -f /root/Base-install.sh

    bash /etc/asterisk/local/pi-monitor/Base.sh

sleep 1   
   
    bash /etc/asterisk/local/pi-monitor/Fetch.sh
   
    echo "First Run - Done"
    echo ""
    echo "Base PI-Monitor Install - Complete"

exit