#!/bin/bash
#
# By -- WRQC343 -- gmrs-link.com
#
# Ver 1.1 - 8/26/24
#
#  Remote 3 install

link="http://gmrs-link.com/rsync/pi-monitor"
lan_ip=$(hostname -i)
wan_ip=$(curl -s https://ipinfo.io/ip)


    echo ""
    echo "Creating Folders"

    mkdir /etc/asterisk/local/pi-monitor || exit 1

sleep 1   

    mkdir /etc/asterisk/local/pi-monitor/sound || exit 1
    
    echo "Folders - Complete"
    echo ""
    
    echo "Downloading Files"
    
    wget -P /etc/asterisk/local/pi-monitor/ $link/Remote3.sh -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/pi-monitor/Remote3.sh
    
    wget -P /etc/asterisk/local/pi-monitor/sound/ $link/sound/high-temp-alarm.gsm -q --show-progress || exit 1
    
    echo "File Download - Complete"
    echo "Permissions Set"
    echo ""
    
    echo "Building File Structure"
   
    ln -s /tmp/pi-temp-4.php /srv/http/pi-temp-4.php
    
    echo "File Structure - Complete"  
    echo ""
    
    echo "Backup Current Cron File"
   
    cp /var/spool/cron/root /var/spool/cron/root_`date +"%Y%m%d"`.bak
   
    echo "Cron Backup - Complete"
    echo ""
    
    echo "Checking Cron for existing entries"
   
    crontab -l | grep '/etc/asterisk/local/pi-monitor/Remote3.sh' 1>/dev/null 2>&1 
    (( $? == 0 )) && echo "Cron Error" && exit  
   
    echo "Cron Check - Complete"
    echo ""
    
    crontab -l >/tmp/crontab.tmp 
  
    echo "Adding Cron Strings"
   
    echo '*/29 * * * * /etc/asterisk/local/pi-monitor/Remote3.sh' >> /tmp/crontab.tmp 
    
    crontab /tmp/crontab.tmp 
 
    rm /tmp/crontab.tmp 
   
    echo "Cron File - Complete"
    echo ""
    
    echo "Your LAN IP Address is: $lan_ip"
    echo "Your WAN IP Address is: $wan_ip"
    echo ""
    echo Enter This Nodes Number #?
    read var1
    echo ""
    
    echo "Checking Files for String Markers"
    
    grep 'xxxx' /etc/asterisk/local/pi-monitor/Remote3.sh >/dev/null 2>&1 
    EXIT="$?"
    
     if [[ "$EXIT" == "0" ]]
  then
	  :

 elif [[ "$EXIT" == "1" ]]
  then
        echo "No matches in files!"
        exit

  else
  	    echo "Encountered an Error: $EXIT."

fi
   
    echo "File Check - Complete"
    echo ""
    
sleep 2

    echo "Adding Remote3.sh Strings"
    
    sed -i 's|'xxxx'|'$var1'|g' /etc/asterisk/local/pi-monitor/Remote3.sh
    
    echo "Data Entry - Complete"
    echo ""
 
sleep 4

    rm -f /root/Remote3-install.sh

    bash /etc/asterisk/local/pi-monitor/Remote3.sh

sleep 1   
   
    echo "First Run - Done"
    echo ""
    echo "Remote-3 PI-Monitor Install - Complete"

exit